package org.jcg.zheng.concurrent;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import org.jcg.zheng.SumTask;

public class NotUsingLockDemo {

	public static void main(String[] args) {
		boolean isSynchronized = false;
		if (args != null && args.length > 0 && "true".equalsIgnoreCase(args[0])) {
			isSynchronized = true;
		}
		
		SumTask sharedResource = new SumTask();
		
		ExecutorService executor = Executors.newFixedThreadPool(3);

		for (int i = 0; i < 1000; i++) {
			executor.execute(new SumTaskRunnable(sharedResource, isSynchronized));
		}

		// Shutdown the ExecutorService
		executor.shutdown();

		try {
			executor.awaitTermination(1, TimeUnit.MINUTES);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		System.out.println("NoLockDemo::main completed. " + sharedResource.getTotal());

	}

}
