package org.jcg.zheng.concurrent;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.ReentrantLock;

import org.jcg.zheng.LockedService;
import org.jcg.zheng.SumTask;

public class ReentrantLockDemo {

	public static void main(String[] args) {
		SumTask sharedResource = new SumTask();
		
		LockedService lockedService = new LockedService(new ReentrantLock(), sharedResource);

		ExecutorService executor = Executors.newFixedThreadPool(3);
		for (int i = 0; i < 1000; i++) {
			executor.execute(new LockedServiceRunnable(lockedService));
		}

		// Shutdown the ExecutorService
		executor.shutdown();

		try {
			executor.awaitTermination(1, TimeUnit.MINUTES);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("ReentrantLockDemo::main completed. " + sharedResource.getTotal());

	}

}
